package com.gic.auth.service.impl;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.gic.auth.dao.mapper.TabSysUserMapper;
import com.gic.auth.dto.UserDTO;
import com.gic.auth.entity.TabSysUser;
import com.gic.auth.service.UserService;
import com.gic.commons.util.EntityUtil;
import org.springframework.transaction.annotation.Transactional;

/**
 * @author guojx
 * @date 2019/7/16 6:52 PM
 */
@Service("userService")
public class UserServiceImpl implements UserService {
    @Autowired
    private TabSysUserMapper tabSysUserMapper;

    @Transactional(rollbackFor = Exception.class)
    @Override
    public int saveUser(UserDTO userDTO) {
        TabSysUser tabUser = EntityUtil.changeEntityNew(TabSysUser.class, userDTO);
        tabSysUserMapper.insert(tabUser);
        return tabUser.getUserId();
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void editUser(UserDTO userDTO) {
        TabSysUser tabUser = EntityUtil.changeEntityNew(TabSysUser.class, userDTO);
        tabSysUserMapper.updateByPrimaryKeySelective(tabUser);
    }

    @Override
    public TabSysUser getUserById(Integer userId) {
        return tabSysUserMapper.selectByPrimaryKey(userId);
    }

    @Override
    public boolean isPhoneRepeat(Integer userId, String phone) {
        int count = tabSysUserMapper.countByPhone(phone, userId);
        if (count > 0) {
            return true;
        }
        return false;
    }

    @Override
    public TabSysUser getUserByEnterpriseId(Integer enterpriseId) {
        return null;
    }

    @Override
    public List<TabSysUser> listAllUserByPhoneNumber(String phoneNumber) {
        return this.tabSysUserMapper.listAllUserByPhoneNumber(phoneNumber);
    }

    @Override
    public TabSysUser login(String phoneNumber, Integer enterpriseId, String password) {
        return this.tabSysUserMapper.login(phoneNumber, password, enterpriseId);
    }
}
